/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.63
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.1 2004/11/24 16:36:38 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.63 2009/09/06 23:04:37 robbat2 Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Original author: John Mylchreest <johnm@gentoo.org>
6# source version, selected kernel options etc. 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :)
8 9
9ECLASS=linux-info 10# @ECLASS: linux-info.eclass
10INHERITED="$INHERITED $ECLASS" 11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
24
25# A Couple of env vars are available to effect usage of this eclass
26# These are as follows:
27
28# @ECLASS-VARIABLE: KERNEL_DIR
29# @DESCRIPTION:
30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
35# A string containing a list of .config options to check for before
36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
40# You can also check that an option doesn't exist by
41# prepending it with an exclamation mark (!).
42#
43# e.g.: CONFIG_CHECK="!MTRR"
44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
59#
60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
61
62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
65# which is to be used as the kernel object directory.
66
67# There are also a couple of variables which are set by this, and shouldn't be
68# set by hand. These are as follows:
69
70# @ECLASS-VARIABLE: KV_FULL
71# @DESCRIPTION:
72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
73
74# @ECLASS-VARIABLE: KV_MAJOR
75# @DESCRIPTION:
76# A read-only variable. It's an integer containing the kernel major version. ie: 2
77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
97# KERNEL_DIR is invalid.
98
99# @ECLASS-VARIABLE: KV_OUT_DIR
100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
107
108# And to ensure all the weirdness with crosscompile
109inherit toolchain-funcs versionator
110
111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND="kernel_linux? ( virtual/linux-sources )"
114RDEPEND=""
11 115
12# Overwritable environment Var's 116# Overwritable environment Var's
13# --------------------------------------- 117# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 118KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 119
16 120
121# Bug fixes
122# fix to bug #75034
123case ${ARCH} in
124 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
125 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
126esac
127
128# @FUNCTION: set_arch_to_kernel
129# @DESCRIPTION:
130# Set the env ARCH to match what the kernel expects.
131set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
132# @FUNCTION: set_arch_to_portage
133# @DESCRIPTION:
134# Set the env ARCH to match what portage expects.
135set_arch_to_portage() { export ARCH=$(tc-arch); }
136
137# qeinfo "Message"
138# -------------------
139# qeinfo is a quiet einfo call when EBUILD_PHASE
140# should not have visible output.
141qout() {
142 local outputmsg type
143 type=${1}
144 shift
145 outputmsg="${@}"
146 case "${EBUILD_PHASE}" in
147 depend) unset outputmsg;;
148 clean) unset outputmsg;;
149 preinst) unset outputmsg;;
150 esac
151 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
152}
153
154qeinfo() { qout einfo "${@}" ; }
155qeerror() { qout eerror "${@}" ; }
17 156
18# File Functions 157# File Functions
19# --------------------------------------- 158# ---------------------------------------
20 159
21# getfilevar accepts 2 vars as follows: 160# @FUNCTION: getfilevar
22# getfilevar <VARIABLE> <CONFIGFILE> 161# @USAGE: variable configfile
23 162# @RETURN: the value of the variable
163# @DESCRIPTION:
164# It detects the value of the variable defined in the file configfile. This is
165# done by including the configfile, and printing the variable with Make.
166# It WILL break if your makefile has missing dependencies!
24getfilevar() { 167getfilevar() {
25local ERROR 168local ERROR basefname basedname myARCH="${ARCH}"
26 ERROR=0 169 ERROR=0
27 170
28 [ -z "${1}" ] && ERROR=1 171 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 172 [ ! -f "${2}" ] && ERROR=1
31 173
32 if [ "${ERROR}" = 1 ] 174 if [ "${ERROR}" = 1 ]
33 then 175 then
176 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 177 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 178 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 179 else
37 grep -e "^$1" $2 | sed 's: = :=:' | cut -d= -f2- 180 basefname="$(basename ${2})"
38 fi 181 basedname="$(dirname ${2})"
39} 182 unset ARCH
40 183
184 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
185 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
186
187 ARCH=${myARCH}
188 fi
189}
190
191# @FUNCTION: getfilevar_noexec
192# @USAGE: variable configfile
193# @RETURN: the value of the variable
194# @DESCRIPTION:
195# It detects the value of the variable defined in the file configfile.
196# This is done with sed matching an expression only. If the variable is defined,
197# you will run into problems. See getfilevar for those cases.
41getfilevar_isset() { 198getfilevar_noexec() {
199 local ERROR basefname basedname mycat myARCH="${ARCH}"
200 ERROR=0
201 mycat='cat'
202
203 [ -z "${1}" ] && ERROR=1
204 [ ! -f "${2}" ] && ERROR=1
205 [ "${2#.gz}" != "${2}" ] && mycat='zcat'
206
207 if [ "${ERROR}" = 1 ]
208 then
209 echo -e "\n"
210 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
211 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
212 else
213 ${mycat} "${2}" | \
214 sed -n \
215 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
216 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
217 s,[[:space:]]*\$,,g ;
218 p
219 }"
220 fi
221}
222
223
224# @FUNCTION: linux_config_src_exists
225# @RETURN: true or false
226# @DESCRIPTION:
227# It returns true if .config exists in a build directory otherwise false
228linux_config_src_exists() {
229 [ -s "${KV_OUT_DIR}/.config" ]
230}
231
232# @FUNCTION: linux_config_bin_exists
233# @RETURN: true or false
234# @DESCRIPTION:
235# It returns true if .config exists in /proc, otherwise false
236linux_config_bin_exists() {
237 [ -s "/proc/config.gz" ]
238}
239
240# @FUNCTION: linux_config_exists
241# @RETURN: true or false
242# @DESCRIPTION:
243# It returns true if .config exists otherwise false
244#
245# This function MUST be checked before using any of the linux_chkconfig_*
246# functions.
247linux_config_exists() {
248 linux_config_src_exists || linux_config_bin_exists
249}
250
251# @FUNCTION: require_configured_kernel
252# @DESCRIPTION:
253# This function verifies that the current kernel is configured (it checks against the existence of .config)
254# otherwise it dies.
255require_configured_kernel() {
256 if ! linux_config_src_exists; then
257 qeerror "Could not find a usable .config in the kernel source directory."
258 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
259 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
260 qeerror "it points to the necessary object directory so that it might find .config."
261 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
262 fi
263}
264
265# @FUNCTION: linux_chkconfig_present
266# @USAGE: option
267# @RETURN: true or false
268# @DESCRIPTION:
269# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
270# If linux_config_exists returns false, the results of this are UNDEFINED. You
271# MUST call linux_config_exists first.
272linux_chkconfig_present() {
42local RESULT 273local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 274 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
275 local config
276 config="${KV_OUT_DIR}/.config"
277 [ ! -f "${config}" ] && config="/proc/config.gz"
278 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 279 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 280}
46 281
47getfilevar_ismodule() { 282# @FUNCTION: linux_chkconfig_module
283# @USAGE: option
284# @RETURN: true or false
285# @DESCRIPTION:
286# It checks that CONFIG_<option>=m is present in the current kernel .config
287# If linux_config_exists returns false, the results of this are UNDEFINED. You
288# MUST call linux_config_exists first.
289linux_chkconfig_module() {
48local RESULT 290local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 291 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
292 local config
293 config="${KV_OUT_DIR}/.config"
294 [ ! -f "${config}" ] && config="/proc/config.gz"
295 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 296 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 297}
52 298
53getfilevar_isbuiltin() { 299# @FUNCTION: linux_chkconfig_builtin
300# @USAGE: option
301# @RETURN: true or false
302# @DESCRIPTION:
303# It checks that CONFIG_<option>=y is present in the current kernel .config
304# If linux_config_exists returns false, the results of this are UNDEFINED. You
305# MUST call linux_config_exists first.
306linux_chkconfig_builtin() {
54local RESULT 307local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 308 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
309 local config
310 config="${KV_OUT_DIR}/.config"
311 [ ! -f "${config}" ] && config="/proc/config.gz"
312 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 313 [ "${RESULT}" = "y" ] && return 0 || return 1
314}
315
316# @FUNCTION: linux_chkconfig_string
317# @USAGE: option
318# @RETURN: CONFIG_<option>
319# @DESCRIPTION:
320# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
321# If linux_config_exists returns false, the results of this are UNDEFINED. You
322# MUST call linux_config_exists first.
323linux_chkconfig_string() {
324 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
325 local config
326 config="${KV_OUT_DIR}/.config"
327 [ ! -f "${config}" ] && config="/proc/config.gz"
328 getfilevar_noexec "CONFIG_${1}" "${config}"
57} 329}
58 330
59# Versioning Functions 331# Versioning Functions
60# --------------------------------------- 332# ---------------------------------------
61 333
62# kernel_is returns true when the version is the same as the passed version 334# @FUNCTION: kernel_is
335# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
336# @RETURN: true or false
337# @DESCRIPTION:
338# It returns true when the current kernel version satisfies the comparison against the passed version.
339# -eq is the default comparison.
63# 340#
341# @CODE
64# For Example where KV = 2.6.9 342# For Example where KV = 2.6.9
65# kernel_is 2 4 returns false 343# kernel_is 2 4 returns false
66# kernel_is 2 returns true 344# kernel_is 2 returns true
67# kernel_is 2 6 returns true 345# kernel_is 2 6 returns true
68# kernel_is 2 6 8 returns false 346# kernel_is 2 6 8 returns false
69# kernel_is 2 6 9 returns true 347# kernel_is 2 6 9 returns true
70# 348# @CODE
349
71# got the jist yet? 350# got the jist yet?
72 351
73kernel_is() { 352kernel_is() {
74 # if we haven't determined the version yet, we need too. 353 # if we haven't determined the version yet, we need to.
75 get_version; 354 get_version
355 local operator test value x=0 y=0 z=0
356
357 case ${1} in
358 lt) operator="-lt"; shift;;
359 gt) operator="-gt"; shift;;
360 le) operator="-le"; shift;;
361 ge) operator="-ge"; shift;;
362 eq) operator="-eq"; shift;;
363 *) operator="-eq";;
364 esac
365
366 for x in ${@}; do
367 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
368 value="${value}${x}"
369 z=$((${z} + 1))
370
371 case ${z} in
372 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
373 test="${test}${KV_MAJOR}";;
374 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
375 test="${test}${KV_MINOR}";;
376 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
377 test="${test}${KV_PATCH}";;
378 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
379 esac
380 done
76 381
77 local RESULT 382 [ ${test} ${operator} ${value} ] && return 0 || return 1
78 RESULT=1
79
80 if [ -n "${1}" ]
81 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0
83 fi
84
85 if [ -n "${2}" ]
86 then
87 RESULT=1
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0
89 fi
90
91 if [ -n "${3}" ]
92 then
93 RESULT=1
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0
95 fi
96 return ${RESULT}
97} 383}
98 384
385get_localversion() {
386 local lv_list i x
387
388 # ignore files with ~ in it.
389 for i in $(ls ${1}/localversion* 2>/dev/null); do
390 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
391 done
392
393 for i in ${lv_list}; do
394 x="${x}$(<${i})"
395 done
396 x=${x/ /}
397 echo ${x}
398}
399
400# internal variable, so we know to only print the warning once
401get_version_warning_done=
402
403# @FUNCTION: get_version
404# @DESCRIPTION:
405# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
406# (if KV_FULL is already set it does nothing).
407#
408# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
409#
410# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
411# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
412# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
99get_version() { 413get_version() {
414 local kbuild_output
415
100 # no need to execute this twice assuming KV_FULL is populated. 416 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 417 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 418 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 419
109 # if we dont know KV_FULL, then we need too. 420 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 421 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 422 unset KV_DIR
112 423
113 # KV_DIR will contain the full path to the sources directory we should use 424 # KV_DIR will contain the full path to the sources directory we should use
425 [ -z "${get_version_warning_done}" ] && \
114 einfo "Determining the location of the kernel source code" 426 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 427 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 428 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 429
118 if [ -z "${KV_DIR}" ] 430 if [ -z "${KV_DIR}" ]
119 then 431 then
432 if [ -z "${get_version_warning_done}" ]; then
433 get_version_warning_done=1
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 434 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 435 #qeinfo "This package requires Linux sources."
436 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
437 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
438 qeinfo "(or the kernel you wish to build against)."
439 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
440 else
441 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
442 fi
122 fi 443 fi
123 444 return 1
445 fi
446
447 if [ -z "${get_version_warning_done}" ]; then
448 qeinfo "Found kernel source directory:"
449 qeinfo " ${KV_DIR}"
450 fi
451
452 if [ ! -s "${KV_DIR}/Makefile" ]
453 then
454 if [ -z "${get_version_warning_done}" ]; then
455 get_version_warning_done=1
456 qeerror "Could not find a Makefile in the kernel source directory."
457 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
458 fi
459 return 1
460 fi
461
462 # OK so now we know our sources directory, but they might be using
463 # KBUILD_OUTPUT, and we need this for .config and localversions-*
464 # so we better find it eh?
465 # do we pass KBUILD_OUTPUT on the CLI?
466 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
467
468 # And if we didn't pass it, we can take a nosey in the Makefile
469 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
470 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
471
124 # And contrary to existing functions I feel we shouldn't trust the 472 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 473 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 474 # so we parse ${KV_DIR}/Makefile
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 475 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 476 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 477 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 478 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
479
480 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
481 then
482 if [ -z "${get_version_warning_done}" ]; then
483 get_version_warning_done=1
484 qeerror "Could not detect kernel version."
485 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
486 fi
487 return 1
488 fi
489
131 # and in newer versions we can also pull LOCALVERSION if it is set. 490 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 491 # but before we do this, we need to find if we use a different object directory.
133 492 # This *WILL* break if the user is using localversions, but we assume it was
493 # caught before this if they are.
494 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
495 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
496
497 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
498 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
499 if [ -n "${KV_OUT_DIR}" ];
500 then
501 qeinfo "Found kernel object directory:"
502 qeinfo " ${KV_OUT_DIR}"
503
504 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
505 fi
506 # and if we STILL have not got it, then we better just set it to KV_DIR
507 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
508
509 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
510 if linux_config_exists; then
511 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
512 KV_LOCAL="${KV_LOCAL//\"/}"
513
514 # For things like git that can append extra stuff:
515 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
516 linux_chkconfig_builtin LOCALVERSION_AUTO &&
517 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
518 fi
519
134 # And we should set KV_FULL to the full expanded version 520 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 521 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 522
137 if [ -z "${KV_FULL}" ] 523 qeinfo "Found sources for kernel version:"
138 then 524 qeinfo " ${KV_FULL}"
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 525
140 eerror "Please check a kernel source exists in this directory." 526 return 0
141 die 527}
528
529# @FUNCTION: get_running_version
530# @DESCRIPTION:
531# It gets the version of the current running kernel and the result is the same as get_version() if the
532# function can find the sources.
533get_running_version() {
534 KV_FULL=$(uname -r)
535
536 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
537 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
538 unset KV_FULL
539 get_version
540 return $?
541 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
542 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
543 unset KV_FULL
544 get_version
545 return $?
142 else 546 else
143 einfo "Found kernel source directory:" 547 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 548 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 549 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 550 KV_PATCH=${KV_PATCH//-*}
551 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
552 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 553 fi
554 return 0
148} 555}
149
150
151 556
152 557
153# ebuild check functions 558# ebuild check functions
154# --------------------------------------- 559# ---------------------------------------
155 560
561# @FUNCTION: check_kernel_built
562# @DESCRIPTION:
563# This function verifies that the current kernel sources have been already prepared otherwise it dies.
156check_kernel_built() { 564check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 565 # if we haven't determined the version yet, we need to
566 require_configured_kernel
158 get_version; 567 get_version
159 568
160 if [ ! -f "${KV_DIR}/System.map" ] 569 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 570 then
162 eerror "These sources have not yet been compiled." 571 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 572 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 573 eerror "To resolve this, please type the following:"
165 eerror 574 eerror
166 eerror "# cd ${KV_DIR}" 575 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 576 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 577 eerror "# make modules_prepare"
169 eerror 578 eerror
170 eerror "Then please try merging this module again." 579 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 580 die "Kernel sources need compiling first"
172 fi 581 fi
173} 582}
174 583
584# @FUNCTION: check_modules_supported
585# @DESCRIPTION:
586# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
175check_modules_supported() { 587check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 588 # if we haven't determined the version yet, we need too.
589 require_configured_kernel
177 get_version; 590 get_version
178 591
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 592 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 593 then
182 eerror "These sources do not support loading external modules." 594 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 595 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 596 eerror "in your kernel, recompile and then try merging this module again."
597 die "No support for external modules in ${KV_FULL} config"
598 fi
599}
600
601# @FUNCTION: check_extra_config
602# @DESCRIPTION:
603# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
604# the prefix ~ is not used) doesn't satisfy the directive.
605check_extra_config() {
606 local config negate die error reworkmodulenames
607 local soft_errors_count=0 hard_errors_count=0 config_required=0
608
609 # if we haven't determined the version yet, we need to
610 get_version
611
612 # Determine if we really need a .config. The only time when we don't need
613 # one is when all of the CONFIG_CHECK options are prefixed with "~".
614 for config in ${CONFIG_CHECK}
615 do
616 if [[ "${config:0:1}" != "~" ]]; then
617 config_required=1
618 break
619 fi
620 done
621
622 if [[ ${config_required} == 0 ]]; then
623 # In the case where we don't require a .config, we can now bail out
624 # if the user has no .config as there is nothing to do. Otherwise
625 # code later will cause a failure due to missing .config.
626 if ! linux_config_exists; then
627 ewarn "Unable to check for the following kernel config options due"
628 ewarn "to absence of any configured kernel sources:"
629 for config in ${CONFIG_CHECK}; do
630 ewarn " - ${config#\~}"
631 done
632 ewarn "You're on your own to make sure they are set if needed."
633 return 0
634 fi
635 else
636 require_configured_kernel
637 fi
638
639 einfo "Checking for suitable kernel configuration options..."
640
641 for config in ${CONFIG_CHECK}
642 do
643 # if we specify any fatal, ensure we honor them
644 die=1
645 error=0
646 negate=0
647 reworkmodulenames=0
648
649 if [[ ${config:0:1} == "~" ]]; then
650 die=0
651 config=${config:1}
652 elif [[ ${config:0:1} == "@" ]]; then
653 die=0
654 reworkmodulenames=1
655 config=${config:1}
656 fi
657 if [[ ${config:0:1} == "!" ]]; then
658 negate=1
659 config=${config:1}
660 fi
661
662 if [[ ${negate} == 1 ]]; then
663 linux_chkconfig_present ${config} && error=2
664 elif [[ ${reworkmodulenames} == 1 ]]; then
665 local temp_config="${config//*:}" i n
666 config="${config//:*}"
667 if linux_chkconfig_present ${config}; then
668 for i in ${MODULE_NAMES}; do
669 n="${i//${temp_config}}"
670 [[ -z ${n//\(*} ]] && \
671 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
672 done
673 error=2
674 fi
675 else
676 linux_chkconfig_present ${config} || error=1
677 fi
678
679 if [[ ${error} > 0 ]]; then
680 local report_func="eerror" local_error
681 local_error="ERROR_${config}"
682 local_error="${!local_error}"
683
684 if [[ -z "${local_error}" ]]; then
685 # using old, deprecated format.
686 local_error="${config}_ERROR"
687 local_error="${!local_error}"
688 fi
689 if [[ ${die} == 0 && -z "${local_error}" ]]; then
690 #soft errors can be warnings
691 local_error="WARNING_${config}"
692 local_error="${!local_error}"
693 if [[ -n "${local_error}" ]] ; then
694 report_func="ewarn"
695 fi
696 fi
697
698 if [[ -z "${local_error}" ]]; then
699 [[ ${error} == 1 ]] \
700 && local_error="is not set when it should be." \
701 || local_error="should not be set. But it is."
702 local_error="CONFIG_${config}:\t ${local_error}"
703 fi
704 if [[ ${die} == 0 ]]; then
705 ${report_func} " ${local_error}"
706 soft_errors_count=$[soft_errors_count + 1]
707 else
708 ${report_func} " ${local_error}"
709 hard_errors_count=$[hard_errors_count + 1]
710 fi
711 fi
712 done
713
714 if [[ ${hard_errors_count} > 0 ]]; then
715 eerror "Please check to make sure these options are set correctly."
716 eerror "Failure to do so may cause unexpected problems."
717 eerror "Once you have satisfied these options, please try merging"
718 eerror "this package again."
719 die "Incorrect kernel configuration options"
720 elif [[ ${soft_errors_count} > 0 ]]; then
721 ewarn "Please check to make sure these options are set correctly."
722 ewarn "Failure to do so may cause unexpected problems."
723 else
724 eend 0
185 fi 725 fi
186} 726}
187 727
188check_zlibinflate() { 728check_zlibinflate() {
189 # if we haven't determined the version yet, we need too. 729 # if we haven't determined the version yet, we need to
730 require_configured_kernel
190 get_version; 731 get_version
191 732
192 # although I restructured this code - I really really really dont support it! 733 # although I restructured this code - I really really really dont support it!
193 734
194 # bug #27882 - zlib routines are only linked into the kernel 735 # bug #27882 - zlib routines are only linked into the kernel
195 # if something compiled into the kernel calls them 736 # if something compiled into the kernel calls them
196 # 737 #
197 # plus, for the cloop module, it appears that there's no way 738 # plus, for the cloop module, it appears that there's no way
198 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 739 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
199 # is on 740 # is on
200 741
201local INFLATE 742 local INFLATE
202local DEFLATE 743 local DEFLATE
203 744
204 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 745 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
205 746
206 ebegin "checking ZLIB_INFLATE" 747 ebegin "checking ZLIB_INFLATE"
207 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 748 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
208 eend $? 749 eend $?
209 [ "$?" != 0 ] && die 750 [ "$?" != 0 ] && die
210 751
211 ebegin "checking ZLIB_DEFLATE" 752 ebegin "checking ZLIB_DEFLATE"
212 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 753 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
213 eend $? 754 eend $?
214 [ "$?" != 0 ] && die 755 [ "$?" != 0 ] && die
215 756
216
217 local LINENO_START 757 local LINENO_START
218 local LINENO_END 758 local LINENO_END
219 local SYMBOLS 759 local SYMBOLS
220 local x 760 local x
221 761
222 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 762 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
223 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 763 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
224 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 764 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
225 (( LINENO_END = $LINENO_END - 1 )) 765 (( LINENO_END = $LINENO_END - 1 ))
226 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 766 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
227 767
228 # okay, now we have a list of symbols 768 # okay, now we have a list of symbols
229 # we need to check each one in turn, to see whether it is set or not 769 # we need to check each one in turn, to see whether it is set or not
230 for x in $SYMBOLS ; do 770 for x in $SYMBOLS ; do
231 if [ "${!x}" = "y" ]; then 771 if [ "${!x}" = "y" ]; then
232 # we have a winner! 772 # we have a winner!
233 einfo "${x} ensures zlib is linked into your kernel - excellent" 773 einfo "${x} ensures zlib is linked into your kernel - excellent"
234 return 0 774 return 0
235 fi 775 fi
236 done 776 done
237 777
238 eerror 778 eerror
239 eerror "This kernel module requires ZLIB library support." 779 eerror "This kernel module requires ZLIB library support."
240 eerror "You have enabled zlib support in your kernel, but haven't enabled" 780 eerror "You have enabled zlib support in your kernel, but haven't enabled"
241 eerror "enabled any option that will ensure that zlib is linked into your" 781 eerror "enabled any option that will ensure that zlib is linked into your"
242 eerror "kernel." 782 eerror "kernel."
252 eerror "Please remember to recompile and install your kernel, and reboot" 792 eerror "Please remember to recompile and install your kernel, and reboot"
253 eerror "into your new kernel before attempting to load this kernel module." 793 eerror "into your new kernel before attempting to load this kernel module."
254 794
255 die "Kernel doesn't include zlib support" 795 die "Kernel doesn't include zlib support"
256} 796}
797
798################################
799# Default pkg_setup
800# Also used when inheriting linux-mod to force a get_version call
801# @FUNCTION: linux-info_pkg_setup
802# @DESCRIPTION:
803# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
804# to support the options specified in CONFIG_CHECK (if not null)
805linux-info_pkg_setup() {
806 get_version
807 if [[ $rc -ne 0 ]]; then
808 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
809 get_running_version
810 fi
811
812 if kernel_is 2 4; then
813 if [ "$( gcc-major-version )" -eq "4" ] ; then
814 echo
815 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
816 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
817 echo
818 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
819 ewarn "newer kernel that supports gcc-4."
820 echo
821 ewarn "Also be aware that bugreports about gcc-4 not working"
822 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
823 echo
824 epause 10
825 fi
826 fi
827
828 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
829}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.63

  ViewVC Help
Powered by ViewVC 1.1.20